Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 6772)
@@ -1595,126 +799,37 @@
                CASE( 'T', 'W' )
 
-                   IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                         je_2 = mje_crs(2)
-                         DO ji = nistr, niend, nn_factx
-                            ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                            zflcrs  =  p_fld(ji  ,je_2) * zsurfmsk(ji  ,je_2) &
-                              &      + p_fld(ji+1,je_2) * zsurfmsk(ji+1,je_2) &
-                              &      + p_fld(ji+2,je_2) * zsurfmsk(ji+2,je_2) 
-                              !
-                             p_fld_crs(ii,2) = zflcrs
-                         ENDDO
-                      ENDIF
-                   ELSE
-                      je_2 = mjs_crs(2)
-                      DO ji = nistr, niend, nn_factx
-                         ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                         zflcrs  =  p_fld(ji  ,je_2  ) * zsurfmsk(ji  ,je_2  )  &
-                           &      + p_fld(ji+1,je_2  ) * zsurfmsk(ji+1,je_2  )  &
-                           &      + p_fld(ji+2,je_2  ) * zsurfmsk(ji+2,je_2  )  &
-                           &      + p_fld(ji  ,je_2+1) * zsurfmsk(ji  ,je_2+1)  &
-                           &      + p_fld(ji+1,je_2+1) * zsurfmsk(ji+1,je_2+1)  &
-                           &      + p_fld(ji+2,je_2+1) * zsurfmsk(ji+2,je_2+1)  &
-                           &      + p_fld(ji  ,je_2+2) * zsurfmsk(ji  ,je_2+2)  &
-                           &      + p_fld(ji+1,je_2+2) * zsurfmsk(ji+1,je_2+2)  &
-                           &      + p_fld(ji+2,je_2+2) * zsurfmsk(ji+2,je_2+2)  
-                            !
-                            p_fld_crs(ii,2) = zflcrs
-                      ENDDO
-                   ENDIF
-                   !
-                   DO jj = njstr, njend, nn_facty
-                      DO ji = nistr, niend, nn_factx
-                         ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-                         ij   = ( jj - njstr ) * rfacty_r + 3
-                         zflcrs  =  p_fld(ji  ,jj  ) * zsurfmsk(ji  ,jj  )  &
-                           &      + p_fld(ji+1,jj  ) * zsurfmsk(ji+1,jj  )  &
-                           &      + p_fld(ji+2,jj  ) * zsurfmsk(ji+2,jj  )  &
-                           &      + p_fld(ji  ,jj+1) * zsurfmsk(ji  ,jj+1)  &
-                           &      + p_fld(ji+1,jj+1) * zsurfmsk(ji+1,jj+1)  &
-                           &      + p_fld(ji+2,jj+1) * zsurfmsk(ji+2,jj+1)  &
-                           &      + p_fld(ji  ,jj+2) * zsurfmsk(ji  ,jj+2)  &
-                           &      + p_fld(ji+1,jj+2) * zsurfmsk(ji+1,jj+2)  &
-                           &      + p_fld(ji+2,jj+2) * zsurfmsk(ji+2,jj+2)  
-                          !
-                          p_fld_crs(ii,ij) = zflcrs
-                          ! 
-                      ENDDO      
-                   ENDDO
+                  DO jj  = nldj_crs,nlej_crs
+                     ijjs = mjs_crs(jj)
+                     ijje = mje_crs(jj)
+                     DO ji = nldi_crs, nlei_crs
+                        ijis = mis_crs(ji)
+                        ijie = mie_crs(ji)
+                        p_fld_crs(ji,jj) = SUM( p_fld(ijis:ijie,ijjs:ijje) * zsurfmsk(ijis:ijie,ijjs:ijje) )
+                     ENDDO
+                  ENDDO
             
                CASE( 'V' )
-                   DO ji = nistr, niend, nn_factx
-                      ii  = ( ji - mis_crs(2) ) * rfactx_r + 2
-                      IF( nldj_crs == 1 .AND. (( mje_crs(2) - mjs_crs(2) ) < 2) )THEN     !!cc bande du sud style ORCA2
-                         IF( mje_crs(2) - mjs_crs(2) == 1 )THEN
-                            jj = mje_crs(2)
-                            zflcrs  = p_fld(ji  ,jj  ) * zsurfmsk(ji  ,jj  )  &
-                             &      + p_fld(ji+1,jj  ) * zsurfmsk(ji+1,jj  )  &
-                             &      + p_fld(ji+2,jj  ) * zsurfmsk(ji+2,jj  )
-                            p_fld_crs(ii,2) = zflcrs
-                         ENDIF
-                      ELSE
-                         ijje = mje_crs(2)
-                         zflcrs  = p_fld(ji  ,ijje) * zsurfmsk(ji  ,ijje)  &
-                           &     + p_fld(ji+1,ijje) * zsurfmsk(ji+1,ijje)  &
-                           &     + p_fld(ji+2,ijje) * zsurfmsk(ji+2,ijje)
-                         !
-                         p_fld_crs(ii,2) = zflcrs
-                      ENDIF
-
-                      DO jj = njstr, njend, nn_facty
-                         ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
-                         ij   = ( jj - njstr ) * rfacty_r + 3
-                         ijje = mje_crs(ij)
-                         ijie = mie_crs(ii)
-                         !                  
-                         zflcrs  = p_fld(ji  ,ijje) * zsurfmsk(ji  ,ijje)  &
-                          &      + p_fld(ji+1,ijje) * zsurfmsk(ji+1,ijje)  &
-                          &      + p_fld(ji+2,ijje) * zsurfmsk(ji+2,ijje)
-                         !
-                         p_fld_crs(ii,ij) = zflcrs
-                         !
-                      ENDDO
-                   ENDDO
-            
+
+                  DO jj  = nldj_crs,nlej_crs
+                     ijjs = mjs_crs(jj)
+                     ijje = mje_crs(jj)
+                     DO ji = nldi_crs, nlei_crs
+                        ijis = mis_crs(ji)
+                        ijie = mie_crs(ji)
+                        p_fld_crs(ji,jj) = SUM( p_fld(ijis:ijie,ijje) * zsurfmsk(ijis:ijie,ijje) )
+                     ENDDO
+                  ENDDO
+
                CASE( 'U' )
 
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                        je_2 = mje_crs(2)
-                        DO ji = nistr, niend, nn_factx
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-                           ijie = mie_crs(ii)
-                           zflcrs  =  p_fld(ijie,je_2) * zsurfmsk(ijie,je_2)  
-                           p_fld_crs(ii,2) = zflcrs
-                        ENDDO
-                     ENDIF
-                  ELSE
-                     je_2 = mjs_crs(2)
-                     DO ji = nistr, niend, nn_factx
-                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-                        ijie = mie_crs(ii)
-                        zflcrs =  p_fld(ijie,je_2  ) * zsurfmsk(ijie,je_2  )  &
-                          &     + p_fld(ijie,je_2+1) * zsurfmsk(ijie,je_2+1)  &
-                          &     + p_fld(ijie,je_2+2) * zsurfmsk(ijie,je_2+2) 
-   
-                        p_fld_crs(ii,2) = zflcrs
+                  DO jj  = nldj_crs,nlej_crs
+                     ijjs = mjs_crs(jj)
+                     ijje = mje_crs(jj)
+                     DO ji = nldi_crs, nlei_crs
+                        ijis = mis_crs(ji)
+                        ijie = mie_crs(ji)
+                        p_fld_crs(ji,jj) = SUM( p_fld(ijie,ijjs:ijje) * zsurfmsk(ijie,ijjs:ijje) )
                      ENDDO
-                 ENDIF
-
-                 DO jj = njstr, njend, nn_facty
-                    DO ji = nistr, niend, nn_factx
-                       ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                       ij   = ( jj - njstr ) * rfacty_r + 3
-                       ijie = mie_crs(ii)
-                       zflcrs =  p_fld(ijie,jj  ) * zsurfmsk(ijie,jj  )  &
-                          &    + p_fld(ijie,jj+1) * zsurfmsk(ijie,jj+1)  &
-                          &    + p_fld(ijie,jj+2) * zsurfmsk(ijie,jj+2) 
-                         !
-                       p_fld_crs(ii,ij) = zflcrs
-                       ! 
-                    ENDDO      
-                 ENDDO
+                  ENDDO
 
               END SELECT
@@ -1731,123 +846,20 @@
             
                CASE( 'T', 'W' )
-  
-                   DO ji = nistr, niend, nn_factx
-                      ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                         IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                            je_2 = mje_crs(2)
-                            zflcrs =  &
-                              & MAX( p_fld(ji  ,je_2) * p_mask(ji  ,je_2,1) - ( 1.- p_mask(ji  ,je_2,1) ) * r_inf ,  &
-                              &      p_fld(ji+1,je_2) * p_mask(ji+1,je_2,1) - ( 1.- p_mask(ji+1,je_2,1) ) * r_inf ,  &
-                              &      p_fld(ji+2,je_2) * p_mask(ji+2,je_2,1) - ( 1.- p_mask(ji+2,je_2,1) ) * r_inf  )
-                            !
-                            p_fld_crs(ii,2) = zflcrs
-                         ENDIF
-                      ELSE
-                         je_2 = mjs_crs(2) 
-                         zflcrs =  &
-                           &  MAX( p_fld(ji  ,je_2  ) * p_mask(ji  ,je_2  ,1) - ( 1.- p_mask(ji  ,je_2  ,1) ) * r_inf ,  &
-                           &       p_fld(ji+1,je_2  ) * p_mask(ji+1,je_2  ,1) - ( 1.- p_mask(ji+1,je_2  ,1) ) * r_inf ,  &
-                           &       p_fld(ji+2,je_2  ) * p_mask(ji+2,je_2  ,1) - ( 1.- p_mask(ji+2,je_2  ,1) ) * r_inf ,  &
-                           &       p_fld(ji  ,je_2+1) * p_mask(ji  ,je_2+1,1) - ( 1.- p_mask(ji  ,je_2+1,1) ) * r_inf ,  &
-                           &       p_fld(ji+1,je_2+1) * p_mask(ji+1,je_2+1,1) - ( 1.- p_mask(ji+1,je_2+1,1) ) * r_inf ,  &
-                           &       p_fld(ji+2,je_2+1) * p_mask(ji+2,je_2+1,1) - ( 1.- p_mask(ji+2,je_2+1,1) ) * r_inf ,  &
-                           &       p_fld(ji  ,je_2+2) * p_mask(ji  ,je_2+2,1) - ( 1.- p_mask(ji  ,je_2+2,1) ) * r_inf ,  &
-                           &       p_fld(ji+1,je_2+2) * p_mask(ji+1,je_2+2,1) - ( 1.- p_mask(ji+1,je_2+2,1) ) * r_inf ,  &
-                           &       p_fld(ji+2,je_2+2) * p_mask(ji+2,je_2+2,1) - ( 1.- p_mask(ji+2,je_2+2,1) ) * r_inf   )
-                         !
-                         p_fld_crs(ii,2) = zflcrs
-                      ENDIF
-
-                      DO jj = njstr, njend, nn_facty
-                         ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                         ij   = ( jj - njstr ) * rfacty_r + 3
-                         zflcrs = &
-                          &  MAX( p_fld(ji  ,jj  ) * p_mask(ji  ,jj  ,1) - ( 1.- p_mask(ji  ,jj  ,1) ) * r_inf ,  &
-                          &       p_fld(ji+1,jj  ) * p_mask(ji+1,jj  ,1) - ( 1.- p_mask(ji+1,jj  ,1) ) * r_inf ,  &
-                          &       p_fld(ji+2,jj  ) * p_mask(ji+2,jj  ,1) - ( 1.- p_mask(ji+2,jj  ,1) ) * r_inf ,  &
-                          &       p_fld(ji  ,jj+1) * p_mask(ji  ,jj+1,1) - ( 1.- p_mask(ji  ,jj+1,1) ) * r_inf ,  &
-                          &       p_fld(ji+1,jj+1) * p_mask(ji+1,jj+1,1) - ( 1.- p_mask(ji+1,jj+1,1) ) * r_inf ,  &
-                          &       p_fld(ji+2,jj+1) * p_mask(ji+2,jj+1,1) - ( 1.- p_mask(ji+2,jj+1,1) ) * r_inf ,  &
-                          &       p_fld(ji  ,jj+2) * p_mask(ji  ,jj+2,1) - ( 1.- p_mask(ji  ,jj+2,1) ) * r_inf ,  &
-                          &       p_fld(ji+1,jj+2) * p_mask(ji+1,jj+2,1) - ( 1.- p_mask(ji+1,jj+2,1) ) * r_inf ,  &
-                          &       p_fld(ji+2,jj+2) * p_mask(ji+2,jj+2,1) - ( 1.- p_mask(ji+2,jj+2,1) ) * r_inf   )
-                         !
-                         p_fld_crs(ii,ij) = zflcrs
-                         !
-                      ENDDO      
-                   ENDDO
+ 
+                  DO jj  = nldj_crs,nlej_crs
+                     ijjs = mjs_crs(jj)
+                     ijje = mje_crs(jj)
+                     DO ji = nldi_crs, nlei_crs
+                        ijis = mis_crs(ji)
+                        ijie = mie_crs(ji)
+                        p_fld_crs(ji,jj) = MAXVAL( p_fld(ijis:ijie,ijjs:ijje) * p_mask(ijis:ijie,ijjs:ijje,1) - &
+                                                 & ( 1._wp - p_mask(ijis:ijie,ijjs:ijje,1) )                    )
+                     ENDDO
+                  ENDDO
             
                CASE( 'V' )
-
-!                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-!                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-!                        ijje = mje_crs(2)
-!                      ENDIF
-!                  ELSE
-!                     ijje = mjs_crs(2)
-!                  ENDIF
-!
-!                  DO ji = nistr, niend, nn_factx
-!                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-!                     zflcrs = MAX( p_fld(ji  ,ijje) * p_mask(ji  ,ijje,1) - ( 1.- p_mask(ji,ijje,1) ) * r_inf ,  &
-!                       &           p_fld(ji+1,ijje) * p_mask(ji+1,ijje,1) - ( 1.- p_mask(ji,ijje,1) ) * r_inf ,  &
-!                       &           p_fld(ji+2,ijje) * p_mask(ji+2,ijje,1) - ( 1.- p_mask(ji,ijje,1) ) * r_inf )
-!                       !
-!                     p_fld_crs(ii,2) = zflcrs
-!                  ENDDO      
-!                  DO jj = njstr, njend, nn_facty
-!                     DO ji = nistr, niend, nn_factx
-!                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-!                        ij   = ( jj - njstr ) * rfacty_r + 3               
-!                        ijje = mje_crs(ij) 
-!                        !                  
-!                        zflcrs = MAX( p_fld(ji  ,ijje) * p_mask(ji  ,ijje,1) - ( 1.- p_mask(ji,ijje,1) ) * r_inf ,  &
-!                          &           p_fld(ji+1,ijje) * p_mask(ji+1,ijje,1) - ( 1.- p_mask(ji,ijje,1) ) * r_inf ,  &
-!                          &           p_fld(ji+2,ijje) * p_mask(ji+2,ijje,1) - ( 1.- p_mask(ji,ijje,1) ) * r_inf )
-!                        !
-!                        p_fld_crs(ii,ij) = zflcrs
-!                        !
-!                     ENDDO      
-!                  ENDDO
                   CALL ctl_stop('MAX operator and V case not available')
             
                CASE( 'U' )
-
-!                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-!                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-!                        je_2 = mje_crs(2)
-!                        DO ji = nistr, niend, nn_factx
-!                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-!                           ijie = mie_crs(ii)
-!                           zflcrs  =  p_fld(ijie,je_2) * p_mask(ijie,je_2,1) - ( 1.- p_mask(ijie,je_2,1) ) * r_inf 
-!                           p_fld_crs(ii,2) = zflcrs
-!                        ENDDO
-!                     ENDIF
-!                 ELSE
-!                     je_2 = mjs_crs(2)
-!                     DO ji = nistr, niend, nn_factx
-!                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-!                        ijie = mie_crs(ii)
-!                        zflcrs =  &
-!                          &  MAX( p_fld(ijie,je_2  ) * p_mask(ijie,je_2  ,1) - ( 1.- p_mask(ijie,je_2,1) ) * r_inf ,  &
-!                          &       p_fld(ijie,je_2+1) * p_mask(ijie,je_2+1,1) - ( 1.- p_mask(ijie,je_2,1) ) * r_inf ,  &
-!                          &       p_fld(ijie,je_2+2) * p_mask(ijie,je_2+2,1) - ( 1.- p_mask(ijie,je_2,1) ) * r_inf  )
-!                        p_fld_crs(ii,2) = zflcrs
-!                     ENDDO
-!                 ENDIF
-!                 DO jj = njstr, njend, nn_facty
-!                    DO ji = nistr, niend, nn_factx
-!                       ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-!                       ij   = ( jj - njstr ) * rfacty_r + 3
-!                       ijie = mie_crs(ii)
-!                       zflcrs =  &
-!                         &  MAX( p_fld(ijie,jj  ) * p_mask(ijie,jj  ,1) - ( 1.- p_mask(ijie,jj,1) ) * r_inf ,  &
-!                         &       p_fld(ijie,jj+1) * p_mask(ijie,jj+1,1) - ( 1.- p_mask(ijie,jj,1) ) * r_inf ,  &
-!                          &      p_fld(ijie,jj+2) * p_mask(ijie,jj+2,1) - ( 1.- p_mask(ijie,jj,1) ) * r_inf  )
-!                        p_fld_crs(ii,ij) = zflcrs
-!                        ! 
-!                     ENDDO      
-!                  ENDDO
                   CALL ctl_stop('MAX operator and U case not available')
 
@@ -1859,129 +871,20 @@
 
               CASE( 'T', 'W' )
-  
-                   IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                      IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                         je_2 = mje_crs(2)
-                         DO ji = nistr, niend, nn_factx
-                            ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                            zflcrs =  &
-                              & MIN( p_fld(ji  ,je_2) * p_mask(ji  ,je_2,1) + ( 1.- p_mask(ji  ,je_2,1) ) * r_inf ,  &
-                             &       p_fld(ji+1,je_2) * p_mask(ji+1,je_2,1) + ( 1.- p_mask(ji+1,je_2,1) ) * r_inf ,  &
-                             &       p_fld(ji+2,je_2) * p_mask(ji+2,je_2,1) + ( 1.- p_mask(ji+2,je_2,1) ) * r_inf  )
-                            !
-                            p_fld_crs(ii,2) = zflcrs
-                         ENDDO
-                      ENDIF
-                   ELSE
-                      DO ji = nistr, niend, nn_factx
-                      ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                      je_2 = mjs_crs(2) 
-                      zflcrs =  &
-                        &  MIN( p_fld(ji  ,je_2  ) * p_mask(ji  ,je_2  ,1) + ( 1.- p_mask(ji  ,je_2  ,1) ) * r_inf ,  &
-                        &       p_fld(ji+1,je_2  ) * p_mask(ji+1,je_2  ,1) + ( 1.- p_mask(ji+1,je_2  ,1) ) * r_inf ,  &
-                        &       p_fld(ji+2,je_2  ) * p_mask(ji+2,je_2  ,1) + ( 1.- p_mask(ji+2,je_2  ,1) ) * r_inf ,  &
-                        &       p_fld(ji  ,je_2+1) * p_mask(ji  ,je_2+1,1) + ( 1.- p_mask(ji  ,je_2+1,1) ) * r_inf ,  &
-                        &       p_fld(ji+1,je_2+1) * p_mask(ji+1,je_2+1,1) + ( 1.- p_mask(ji+1,je_2+1,1) ) * r_inf ,  &
-                        &       p_fld(ji+2,je_2+1) * p_mask(ji+2,je_2+1,1) + ( 1.- p_mask(ji+2,je_2+1,1) ) * r_inf ,  &
-                        &       p_fld(ji  ,je_2+2) * p_mask(ji  ,je_2+2,1) + ( 1.- p_mask(ji  ,je_2+2,1) ) * r_inf ,  &
-                        &       p_fld(ji+1,je_2+2) * p_mask(ji+1,je_2+2,1) + ( 1.- p_mask(ji+1,je_2+2,1) ) * r_inf ,  &
-                        &       p_fld(ji+2,je_2+2) * p_mask(ji+2,je_2+2,1) + ( 1.- p_mask(ji+2,je_2+2,1) ) * r_inf   )
-                      !
-                      p_fld_crs(ii,2) = zflcrs
-                      ENDDO
-                   ENDIF
-
-                   DO jj = njstr, njend, nn_facty
-                      DO ji = nistr, niend, nn_factx
-                         ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                         ij   = ( jj - njstr ) * rfacty_r + 3
-                         zflcrs = &
-                          &  MIN( p_fld(ji  ,jj  ) * p_mask(ji  ,jj  ,1) + ( 1.- p_mask(ji  ,jj  ,1) ) * r_inf ,  &
-                          &       p_fld(ji+1,jj  ) * p_mask(ji+1,jj  ,1) + ( 1.- p_mask(ji+1,jj  ,1) ) * r_inf ,  &
-                          &       p_fld(ji+2,jj  ) * p_mask(ji+2,jj  ,1) + ( 1.- p_mask(ji+2,jj  ,1) ) * r_inf ,  &
-                          &       p_fld(ji  ,jj+1) * p_mask(ji  ,jj+1,1) + ( 1.- p_mask(ji  ,jj+1,1) ) * r_inf ,  &
-                          &       p_fld(ji+1,jj+1) * p_mask(ji+1,jj+1,1) + ( 1.- p_mask(ji+1,jj+1,1) ) * r_inf ,  &
-                          &       p_fld(ji+2,jj+1) * p_mask(ji+2,jj+1,1) + ( 1.- p_mask(ji+2,jj+1,1) ) * r_inf ,  &
-                          &       p_fld(ji  ,jj+2) * p_mask(ji  ,jj+2,1) + ( 1.- p_mask(ji  ,jj+2,1) ) * r_inf ,  &
-                          &       p_fld(ji+1,jj+2) * p_mask(ji+1,jj+2,1) + ( 1.- p_mask(ji+1,jj+2,1) ) * r_inf ,  &
-                          &       p_fld(ji+2,jj+2) * p_mask(ji+2,jj+2,1) + ( 1.- p_mask(ji+2,jj+2,1) ) * r_inf   )
-                         !
-                         p_fld_crs(ii,ij) = zflcrs
-                         !
-                      ENDDO      
-                   ENDDO
+
+                  DO jj  = nldj_crs,nlej_crs
+                     ijjs = mjs_crs(jj)
+                     ijje = mje_crs(jj)
+                     DO ji = nldi_crs, nlei_crs
+                        ijis = mis_crs(ji)
+                        ijie = mie_crs(ji)
+                        p_fld_crs(ji,jj) = MINVAL( p_fld(ijis:ijie,ijjs:ijje) * p_mask(ijis:ijie,ijjs:ijje,1) + &
+                                                 & ( 1._wp - p_mask(ijis:ijie,ijjs:ijje,1) )                    )
+                     ENDDO
+                  ENDDO
             
                CASE( 'V' )
-
-!                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-!                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-!                        ijje = mje_crs(2)
-!                      ENDIF
-!                  ELSE
-!                     ijje = mjs_crs(2)
-!                  ENDIF
-!
-!                  DO ji = nistr, niend, nn_factx
-!                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-!                     zflcrs = MIN( p_fld(ji  ,ijje) * p_mask(ji  ,ijje,1) + ( 1.- p_mask(ji,ijje,1) ) * r_inf ,  &
-!                       &           p_fld(ji+1,ijje) * p_mask(ji+1,ijje,1) + ( 1.- p_mask(ji,ijje,1) ) * r_inf ,  &
-!                       &           p_fld(ji+2,ijje) * p_mask(ji+2,ijje,1) + ( 1.- p_mask(ji,ijje,1) ) * r_inf )
-!                       !
-!                     p_fld_crs(ii,2) = zflcrs
-!                  ENDDO      
-!                  DO jj = njstr, njend, nn_facty
-!                     DO ji = nistr, niend, nn_factx
-!                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-!                        ij   = ( jj - njstr ) * rfacty_r + 3               
-!                        ijje = mje_crs(ij) 
-!                        !                  
-!                        zflcrs = MIN( p_fld(ji  ,ijje) * p_mask(ji  ,ijje,1) + ( 1.- p_mask(ji,ijje,1) ) * r_inf ,  &
-!                          &           p_fld(ji+1,ijje) * p_mask(ji+1,ijje,1) + ( 1.- p_mask(ji,ijje,1) ) * r_inf ,  &
-!                          &           p_fld(ji+2,ijje) * p_mask(ji+2,ijje,1) + ( 1.- p_mask(ji,ijje,1) ) * r_inf )
-!                        !
-!                        p_fld_crs(ii,ij) = zflcrs
-!                        !
-!                     ENDDO      
-!                  ENDDO
                   CALL ctl_stop('MIN operator and V case not available')
             
                CASE( 'U' )
-
-!                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-!                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-!                        je_2 = mje_crs(2)
-!                        DO ji = nistr, niend, nn_factx
-!                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-!                           ijie = mie_crs(ii)
-!                           zflcrs  =  p_fld(ijie,je_2) * p_mask(ijie,je_2,1) + ( 1.- p_mask(ijie,je_2,1) ) * r_inf 
-! 
-!                           p_fld_crs(ii,2) = zflcrs
-!                        ENDDO
-!                     ENDIF
-!                 ELSE
-!                     je_2 = mjs_crs(2)
-!                     DO ji = nistr, niend, nn_factx
-!                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-!                        ijie = mie_crs(ii)
-!                        zflcrs =  &
-!                          &  MIN( p_fld(ijie,je_2  ) * p_mask(ijie,je_2  ,1) + ( 1.- p_mask(ijie,je_2,1) ) * r_inf ,  &
-!                          &       p_fld(ijie,je_2+1) * p_mask(ijie,je_2+1,1) + ( 1.- p_mask(ijie,je_2,1) ) * r_inf ,  &
-!                          &       p_fld(ijie,je_2+2) * p_mask(ijie,je_2+2,1) + ( 1.- p_mask(ijie,je_2,1) ) * r_inf  )
-!                        p_fld_crs(ii,2) = zflcrs
-!                     ENDDO
-!                 ENDIF
-!                 DO jj = njstr, njend, nn_facty
-!                    DO ji = nistr, niend, nn_factx
-!                       ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-!                       ij   = ( jj - njstr ) * rfacty_r + 3
-!                       ijie = mie_crs(ii)
-!                       zflcrs =  &
-!                         &  MIN( p_fld(ijie,jj  ) * p_mask(ijie,jj  ,1) + ( 1.- p_mask(ijie,jj,1) ) * r_inf ,  &
-!                         &       p_fld(ijie,jj+1) * p_mask(ijie,jj+1,1) + ( 1.- p_mask(ijie,jj,1) ) * r_inf ,  &
-!                          &      p_fld(ijie,jj+2) * p_mask(ijie,jj+2,1) + ( 1.- p_mask(ijie,jj,1) ) * r_inf  )
-!                        p_fld_crs(ii,ij) = zflcrs
-!                        ! 
-!                     ENDDO      
-!                  ENDDO
                   CALL ctl_stop('MIN operator and U case not available')
 
